clc
clear all
close all

%% We Define These Variables For Claculating Final Results
Total_IdleTime = zeros(1,20);Max_Qeue_Lentgh= zeros(1,20);
AverageDelay= zeros(1,20);CountOfClient= zeros(1,20);
AverageTime_WaitingCostumerInQeue = zeros(1,20);

for i = 1:20
    
    sim_clock = 0;
    last_event_time = 0;
    Delay_Sum = 0;
    
    NextArrival_1 = 35 + (35-10)*rand();NextArrival_2 = 0;
    sim_clock = NextArrival_1;
    Total_IdleTime(i) = NextArrival_1;
    
    NextDeparture = NextArrival_1 + (18 + (18 - 6)*rand());
    
    NextArrival_1 = NextArrival_1 + 35 + (35-10)*rand();
    NextArrival_2 =  (60 + (60 - 20)*rand());
    
    Client_Qeue_List = [];Count_InQeue_Client = 0;
    
    while sim_clock < 480
        
        %% Updating Time According To Final Departure
        last_departure = sim_clock;
        sim_clock = NextDeparture;
        
        %% Entering Costumers
        while NextArrival_1 <= NextDeparture && NextArrival_1 < 4800
            Client_Qeue_List = [Client_Qeue_List;NextArrival_1,1];
            Count_InQeue_Client = Count_InQeue_Client + 1;
            NextArrival_1 = NextArrival_1 + 35 + (35-10)*rand();
        end
        while NextArrival_2 <= NextDeparture && NextArrival_2 < 4800
            Client_Qeue_List = [Client_Qeue_List;NextArrival_2,2];
            Count_InQeue_Client = Count_InQeue_Client + 1;
            NextArrival_2 = NextArrival_2 + (60 + (60 - 20)*rand());
        end
        
        if length(Client_Qeue_List) > Max_Qeue_Lentgh(i)
                Max_Qeue_Lentgh(i) = length(Client_Qeue_List);
        end
        %% After Exiting a Costumer Barber Select a Costumer From Qeue Or Wait For Entering A Costumer
        if ~isempty(Client_Qeue_List)
            %% Sorting Qeue According To Time Arrival
            [b,idx] = sort(Client_Qeue_List,1);
            Client_Qeue_List = Client_Qeue_List(idx(:,1),:);
            
            
            %% Selecting Next Costumer From  First Of Qeue
            Client_Entrance = Client_Qeue_List(1,1);
            Client_Type = Client_Qeue_List(1,2);
            Client_Qeue_List(1,:)=[];
            
            %% Calculating Time of Departure of Selected Costumer
            if Client_Type == 1
                NextDeparture = sim_clock +  (18 + (18 - 6)*rand());
            else
                NextDeparture = sim_clock +  (28 + (28 - 8)*rand());
            end
            %% If Costumer Has Waited In Qeue, her waited time is calculated
            if Client_Entrance < sim_clock
                Delay =  sim_clock - Client_Entrance ;
                Delay_Sum = Delay_Sum + Delay;
            else
                Delay = 0;
            end
            %% After Exiting A Costumer,We increase the count of clients that we service them
            CountOfClient(i) = CountOfClient(i) + 1;
        else
            %% If there is not any waiting costumer,barber must wait for first
            %% costumer
            last_departure = sim_clock;
            if NextArrival_1 < NextArrival_2
                sim_clock = NextArrival_1;
                NextDeparture = sim_clock +  (18 + (18 - 6)*rand());
                NextArrival_1 = NextArrival_1 + 35 + (35-10)*rand();
            else
                sim_clock = NextArrival_2;
                NextDeparture = sim_clock +  (28 + (28 - 8)*rand());
                NextArrival_2 = NextArrival_2 + (60 + (60 - 20)*rand());
            end
            %% If Barber has Waited For New Arrival,We Must Calculate The Time he were Idle
            Total_IdleTime(i) = Total_IdleTime(i) + (sim_clock - last_departure);
            CountOfClient(i) = CountOfClient(i) + 1;
        end
    end
    %% Calculating AVerage of Delay,Percent of Barber Idle Time And Time Average Of Clients In Qeue
    AverageDelay(i) = Delay_Sum / Count_InQeue_Client;
    Total_IdleTime(i)=  Total_IdleTime(i) / sim_clock;
    AverageTime_WaitingCostumerInQeue(i) = Count_InQeue_Client/sim_clock;
end

%% In this section we calculate final result for each variable
t = 2.093;
%% Hade Aksare Toule Saf
Avg_Max_Qeue_Lentgh = mean(Max_Qeue_Lentgh);
S_Max_Qeue_Lentgh = sum((Max_Qeue_Lentgh - Avg_Max_Qeue_Lentgh).*(Max_Qeue_Lentgh - Avg_Max_Qeue_Lentgh))/19;
Final_Result(1,1) = Avg_Max_Qeue_Lentgh - t*S_Max_Qeue_Lentgh/sqrt(20);
Final_Result(1,2) = Avg_Max_Qeue_Lentgh + t*S_Max_Qeue_Lentgh/sqrt(20);
%% Motevasete Zamane Entezare Moshtarian Dar Saf
Avg_Delay = mean(AverageDelay);
S_AverageDelay = sum((AverageDelay-Avg_Delay).*(AverageDelay-Avg_Delay))/19;
Final_Result(2,1) =Avg_Delay - t*S_AverageDelay/sqrt(20);
Final_Result(2,2) = Avg_Delay + t*S_AverageDelay/sqrt(20);
%% Motevasete Zamanie Tedade Moshtarian Dar Saf
AQ = mean(AverageTime_WaitingCostumerInQeue);
S_ATimeWaitingCostumerInQeue = sum((AverageTime_WaitingCostumerInQeue - AQ).*(AverageTime_WaitingCostumerInQeue - AQ))/19;
Final_Result(3,1) = AQ - t*S_ATimeWaitingCostumerInQeue/sqrt(20);
Final_Result(3,2) = AQ + t*S_ATimeWaitingCostumerInQeue/sqrt(20);
%% Darsade Bikarie Araieshgar
Avg_Total_IdleTime = mean(Total_IdleTime);
S_Total_IdleTime = sum((Total_IdleTime - Avg_Total_IdleTime).*(Total_IdleTime - Avg_Total_IdleTime))/19;
Final_Result(4,1) = Avg_Total_IdleTime - t*S_Total_IdleTime/sqrt(20);
Final_Result(4,2) = Avg_Total_IdleTime + t*S_Total_IdleTime/sqrt(20);
%% Writing Result In excel file
xlswrite('Result',[Max_Qeue_Lentgh',AverageDelay', AverageTime_WaitingCostumerInQeue',Total_IdleTime'],'sheet1');
xlswrite('Result',Final_Result,'sheet2');
AAA = [Max_Qeue_Lentgh',AverageDelay', AverageTime_WaitingCostumerInQeue',Total_IdleTime'];
